/*
	Host container communication test code for GNU Flash Player
	Written (2015) by Nutchanon Wetchasit <Nutchanon.Wetchasit@gmail.com>
	
	Released under Creative Commons Public Domain Dedication 1.0
	(https://creativecommons.org/publicdomain/zero/1.0/)
*/
import flash.external.*;

class HostCommunicationTest {
	public static function main(mc:MovieClip):Void {
		var retval;
		
		// Run test only once
		if(mc.started) {
			return;
		}
		mc.started = true;
		
		// Assign _root.someVariable
		mc.someVariable = "Hello there?";
		
		// ExternalInterface callback registration and invocation
		if(!ExternalInterface.available) {
			// ExternalInterface is not available
			trace("hostcomm: ExternalInterface is not available");
		} else {
			// ExternalInterface callback test
			trace("hostcomm: registering ExternalInterface callback...");
			retval = ExternalInterface.addCallback(
				"flash_function",
				null,
				function(arg1, arg2, arg3) {
					trace("hostcomm: ExternalInterface callback invoked: arguments (" + arg1 + ", " + arg2 + ", " + arg3 + ") this = " + this);
					return "over a lazy dog.";
				}
			);
			trace("hostcomm: ExternalInterface callback registration " + (retval ? "succeeded" : "failed"));
			
			// JavaScript function call test
			trace("hostcomm: Calling JavaScript function...");
			retval = flash.external.ExternalInterface.call(
				"script_function",
				"Hello",
				"World!"
			);
			trace("hostcomm: JavaScript function returned: " + retval);
		}
		
		// MovieClip.getURL() test
		trace("hostcomm: starting MovieClip.getURL()...");
		mc.getURL("http://www.gnu.org/", "_blank");
		
		// global getURL() test
		trace("hostcomm: starting global getURL()...");
		getURL("http://savannah.gnu.org/", "_blank");
		
		// fscommand() test
		trace("hostcomm: starting fscommand()...");
		fscommand("lorem", "ipsum");
	}
}
